"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const armPattern_1 = require("./armPattern");
class ArmPatternKnotMatrix {
    constructor(firstLine, otherLine, lastLine) {
        this.firstLine = firstLine;
        this.otherLine = otherLine;
        this.lastLine = lastLine;
    }
    static fromChars(firstChars, otherChars, lastChars, style) {
        const lineDependentArmPattern = new ArmPatternKnotMatrix(armPattern_1.ArmPattern.fromChars(firstChars, style), armPattern_1.ArmPattern.fromChars(otherChars, style), armPattern_1.ArmPattern.fromChars(lastChars, style));
        return lineDependentArmPattern;
    }
}
exports.ArmPatternKnotMatrix = ArmPatternKnotMatrix;
class ArmPatternMatrix {
    constructor(infertileLeaf, fertileLeaf, firstChild, otherChild, lastChild) {
        this.infertileLeaf = infertileLeaf;
        this.fertileLeaf = fertileLeaf;
        this.firstChild = firstChild;
        this.otherChild = otherChild;
        this.lastChild = lastChild;
    }
    static fromArray(array, style) {
        const knotDependentArmPlainLinePattern = new ArmPatternMatrix(ArmPatternKnotMatrix.fromChars(array[0], array[1], array[2], style), ArmPatternKnotMatrix.fromChars(array[3], array[4], array[5], style), ArmPatternKnotMatrix.fromChars(array[6], array[7], array[8], style), ArmPatternKnotMatrix.fromChars(array[9], array[10], array[11], style), ArmPatternKnotMatrix.fromChars(array[12], array[13], array[14], style));
        return knotDependentArmPlainLinePattern;
    }
    static fromCommonChars(otherChildFirstLine, spacer, lastChildFirstLine, style) {
        const knotDependentArmPlainLinePattern = new ArmPatternMatrix(ArmPatternKnotMatrix.fromChars(otherChildFirstLine, spacer, spacer, style), ArmPatternKnotMatrix.fromChars(otherChildFirstLine, spacer, spacer, style), ArmPatternKnotMatrix.fromChars(otherChildFirstLine, spacer, spacer, style), ArmPatternKnotMatrix.fromChars(otherChildFirstLine, spacer, spacer, style), ArmPatternKnotMatrix.fromChars(lastChildFirstLine, '   ', '   ', style));
        return knotDependentArmPlainLinePattern;
    }
}
exports.ArmPatternMatrix = ArmPatternMatrix;
//# sourceMappingURL=armPatternMatrix.js.map