"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const textContainer_1 = require("../text/textContainer");
const strictUnicode_1 = require("../text/strictUnicode");
class MetaNode {
    constructor(leaf, armGenerator, armWidthGenerator) {
        this.leaf = leaf;
        this.armGenerator = armGenerator;
        this.armWidthGenerator = armWidthGenerator;
        this.children = [];
    }
    static fromString(text, armGenerator, armWidthGenerator) {
        const leaf = new textContainer_1.AtomicTextContainer(new strictUnicode_1.StrictUnicodeText(text));
        const metaNode = new MetaNode(leaf, armGenerator, armWidthGenerator);
        return metaNode;
    }
}
exports.MetaNode = MetaNode;
//# sourceMappingURL=node.js.map