"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const style_1 = require("../text/style");
const nodeType_1 = require("./interfaces/nodeType");
const color = {
    brightGreen: { r: 130, g: 240, b: 130 },
    green: { r: 80, g: 160, b: 80 },
    darkGreen: { r: 64, g: 128, b: 64 },
    blue: { r: 160, g: 160, b: 220 },
    darkBlue: { r: 64, g: 64, b: 160 },
    darkGray: { r: 64, g: 64, b: 64 },
    darkGrayGreen: { r: 54, g: 84, b: 54 },
    darkGrayBlue: { r: 54, g: 54, b: 84 },
    gray: { r: 128, g: 128, b: 128 },
    lightGray: { r: 192, g: 192, b: 192 },
    white: { r: 255, g: 255, b: 255 },
    orange: { r: 255, g: 128, b: 0 },
};
const style = {
    icon: new style_1.Style(color.brightGreen),
    dim: new style_1.Style(color.darkGray),
    key: new style_1.Style(color.green),
    keyDelimeter: new style_1.Style(color.darkGreen),
    value: new style_1.Style(color.white),
    infoDelimeter: new style_1.Style(color.darkBlue),
    info: new style_1.Style(color.blue),
    branch: {
        [nodeType_1.NodeBroadTypeEnum.Dead]: new style_1.Style(color.orange),
        [nodeType_1.NodeBroadTypeEnum.Single]: new style_1.Style(color.orange),
        [nodeType_1.NodeBroadTypeEnum.Iterable]: new style_1.Style(color.darkGrayGreen),
        [nodeType_1.NodeBroadTypeEnum.Enumerable]: new style_1.Style(color.darkGrayBlue),
    },
    warning: new style_1.Style(color.orange),
};
exports.theme = {
    color,
    style
};
//# sourceMappingURL=defaultThemeOld.js.map