import { AnyTextContainer, FlatNonatomicTextContainer } from '../../textContainer';
import { Renderer, renderResultT } from './renderer';
import { StrictUnicodeLine } from '../../strictUnicode';
import { Style } from '../../style';
export declare abstract class SimpleRenderer extends Renderer {
    render(textContainer: AnyTextContainer): renderResultT;
    renderFlat(flatTextContainer: FlatNonatomicTextContainer): renderResultT;
    renderFlatFeedLines(flatFeedLines: FlatNonatomicTextContainer<StrictUnicodeLine>[]): renderResultT;
    renderFlatFeedLine(flatFeedLineContainer: FlatNonatomicTextContainer<StrictUnicodeLine>): renderResultT;
    renderFlatLine(flatLineContainer: FlatNonatomicTextContainer<StrictUnicodeLine>): renderResultT;
    renderLine(lineContainer: AnyTextContainer<StrictUnicodeLine>): renderResultT;
    protected abstract escapeText(text: string): string;
    protected abstract styleBegin(style: Style | undefined): string;
    protected abstract styleEnd(style: Style | undefined): string;
    abstract eol: string;
}
//# sourceMappingURL=simpleRenderer.d.ts.map