"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
// eslint-disable-next-line @typescript-eslint/no-var-requires
const ansiStyleLib = require('ansi-styles');
const styleTypes_1 = require("../../styleTypes");
const os_1 = require("os");
const simpleRenderer_1 = require("../abstract/simpleRenderer");
const strictRgb_1 = require("../abstract/strictRgb");
class AnsiRenderer extends simpleRenderer_1.SimpleRenderer {
    constructor() {
        super(...arguments);
        this.eol = os_1.EOL;
    }
    styleBegin(style) {
        let styleString = '';
        if (style) {
            if (style.background) {
                const strictBackground = strictRgb_1.strictRgb(style.background);
                styleString += ansiStyleLib.bgColor.ansi16m.rgb(strictBackground.r, strictBackground.g, strictBackground.b);
            }
            if (style.foreground) {
                const strictForeground = strictRgb_1.strictRgb(style.foreground);
                styleString += ansiStyleLib.color.ansi16m.rgb(strictForeground.r, strictForeground.g, strictForeground.b);
            }
            if (style.switches[styleTypes_1.StyleSwitchesEnum.Bold]) {
                styleString += ansiStyleLib.bold.open;
            }
            if (style.switches[styleTypes_1.StyleSwitchesEnum.Italic]) {
                styleString += ansiStyleLib.italic.open;
            }
            if (style.switches[styleTypes_1.StyleSwitchesEnum.Underline]) {
                styleString += ansiStyleLib.underline.open;
            }
        }
        return styleString;
    }
    styleEnd(style) {
        let styleString = '';
        if (style) {
            if (style.background) {
                styleString += ansiStyleLib.bgColor.close;
            }
            if (style.foreground) {
                styleString += ansiStyleLib.color.close;
            }
            if (style.switches[styleTypes_1.StyleSwitchesEnum.Bold]) {
                styleString += ansiStyleLib.bold.close;
            }
            if (style.switches[styleTypes_1.StyleSwitchesEnum.Italic]) {
                styleString += ansiStyleLib.italic.close;
            }
            if (style.switches[styleTypes_1.StyleSwitchesEnum.Underline]) {
                styleString += ansiStyleLib.underline.close;
            }
        }
        return styleString;
    }
    escapeText(text) {
        return text;
    }
}
exports.AnsiRenderer = AnsiRenderer;
//# sourceMappingURL=ansi.js.map